<?php
/* VR pay eCommerce easyCredit checkout controller
 *
 * @version 2.3.03
 * @date 2018-01-03
 *
 */
include_once(dirname(__FILE__) . '/../vrpayecommerce/vrpayecommerce.php');

class ControllerCheckoutVrpayecommerceEasycredit extends ControllerVrpayecommerce {
	protected $code = "vrpayecommerce_easycredit";
	protected $redirect = true;
	protected $brand = "RATENKAUF";
	protected $logo = "easycredit.png";
	protected $template = 'extension/payment/vrpayecommerce/server_to_server_request.tpl';
	protected $payment_type = 'PA';

	/**
	 * Get customer created date
	 *
	 * @return array
	 */
	 protected function getPaymentParameters() {
	 	$payment_parameters = parent::getPaymentParameters();
		$order_info = $this->getOrderInfo();

		$payment_parameters['customer']['sex'] = $this->getCustomerSex($order_info['custom_field']);
		$payment_parameters['customer']['birthdate'] = $this->getCustomerDob($order_info['custom_field']);
		$payment_parameters['customer']['phone'] = $order_info['telephone'];
		$payment_parameters['cartItems'] = $this->getCartItems();
		$payment_parameters['customParameters']['RISK_ANZAHLBESTELLUNGEN'] = $this->getCustomerTotalOrdersByCompleteStatus();
		$payment_parameters['customParameters']['RISK_BESTELLUNGERFOLGTUEBERLOGIN'] = $this->isCustomerLogin();
		$payment_parameters['customParameters']['RISK_KUNDENSTATUS'] = $this->getRiskKundenStatus();
		$payment_parameters['customParameters']['RISK_KUNDESEIT'] = $this->getCustomerCreatedDate();
		$payment_parameters['paymentBrand'] = $this->getBrand();

		if(isset($order_info['shipping_city']) && $order_info['shipping_city']!='') {
			$payment_parameters['shipping']['city'] = $order_info['shipping_city'];
		} else {
			$payment_parameters['shipping']['city'] = $order_info['payment_city'];
		}

		if(isset($order_info['shipping_iso_code_2']) && $order_info['shipping_iso_code_2']!='') {
			$payment_parameters['shipping']['country'] = $order_info['shipping_iso_code_2'];
		} else {
			$payment_parameters['shipping']['country'] = $order_info['payment_iso_code_2'];
		}

		if(isset($order_info['shipping_postcode']) && $order_info['shipping_postcode']!='') {
			$payment_parameters['shipping']['postcode'] = $order_info['shipping_postcode'];
		} else {
			$payment_parameters['shipping']['postcode'] = $order_info['payment_postcode'];
		}

		if(isset($order_info['shipping_address_1']) && $order_info['shipping_address_1']!='') {
			$payment_parameters['shipping']['street1'] = $order_info['shipping_address_1'];
		} else {
			$payment_parameters['shipping']['street1'] = $order_info['payment_address_1'];
		}

		$payment_parameters['shopperResultUrl'] = $this->url->link('extension/payment/' . $this->code . '/confirmPage', '', true);
		
		return $payment_parameters;
	}
	 
	protected function getCustomerCreatedDate()
	{
		if ($this->isCustomerLogin() == 'true') {
			$customer_id = (int)$this->customer->getId();
			$query = $this->db->query("SELECT date_added FROM `" . DB_PREFIX . "order` WHERE customer_id =" . $customer_id);
			$customer_date_added = date("Y-m-d", strtotime($query->row['date_added']));
			return $customer_date_added;
		}
		return date('Y-m-d');
	}

	/**
	 * Get risk kunden status
	 *
	 * @return string|boolean
	 */
	protected function getRiskKundenStatus()
	{
		if ($this->getCustomerTotalOrdersByCompleteStatus() > 0) {
			return 'BESTANDSKUNDE';
		}
		return 'NEUKUNDE';
	}

	/**
	 * Get the customer total order
	 *
	 * @param array $order_info
	 * @return int
	 */
	public function getCustomerTotalOrdersByCompleteStatus()
	{
		if ($this->isCustomerLogin() == 'true') {
			$implode = array();
			$vrpayecommerce_complete_statuses = (int)$this->config->get('vrpayecommerce_ageneral_accept_status_id');
			$order_statuses = $this->config->get('config_complete_status');
			$customer_id = (int)$this->customer->getId();

			foreach ($order_statuses as $order_status_id) {
				$implode[] = "order_status_id = '" . (int)$order_status_id . "'";
			}

			if ($implode) {
				$query = $this->db->query("SELECT COUNT(*) AS total FROM `" . DB_PREFIX . "order` WHERE (" . implode(" OR ", $implode) . " OR order_status_id='" .
				$vrpayecommerce_complete_statuses . "') AND  customer_id=" . $customer_id);

				return (int)$query->row['total'];
			}
			return 0;
		}
		return 0;
	}
}
