<?php
/* VR pay eCommerce Paydirekt checkout controller
 *
 * @version 2.3.03
 * @date 2018-01-03
 *
 */
include_once(dirname(__FILE__) . '/../vrpayecommerce/vrpayecommerce.php');

class ControllerCheckoutVrpayecommercePaydirekt extends ControllerVrpayecommerce {
	protected $code = "vrpayecommerce_paydirekt";
	protected $brand = "PAYDIREKT";
	protected $redirect = true;
	protected $logo = "paydirekt.png";

	/**
	 * Get a payment type
	 *
	 * @return  string
	 */
	function getPaymentType()
	{
	  return $this->getPaymentTypeSelection();
	}

	/**
	 * Get payment parameters
	 *
	 * @return array
	 */
	protected function getPaymentParameters() {
		$payment_parameters = parent::getPaymentParameters();
		$order_info = $this->getOrderInfo();
		$payment_parameters['customer']['birthdate'] = $this->getCustomerDob($order_info['custom_field']);
		$payment_parameters['customer']['sex'] = $this->getCustomerSex($order_info['custom_field']);
		$payment_parameters['customer']['phone'] = $order_info['telephone'];
		$payment_parameters['customParameters']['PAYDIREKT_minimumAge'] = $this->getMinimumAge();
		$payment_parameters['customParameters']['PAYDIREKT_payment.isPartial'] = $this->getPaymentIsPartial();

		return $payment_parameters;
	}
}
