<?php
/* VR pay eCommerce Direct Debit (recurring) payment controller
 *
 * @version 2.3.03
 * @date 2018-01-03
 *
 */
include_once(dirname(__FILE__) . '/../../vrpayecommerce/vrpayecommerce.php');

class ControllerExtensionPaymentVrpayecommerceDdSaved extends ControllerVrpayecommerce {
	protected $account_type = 'bankAccount';
	protected $code = 'vrpayecommerce_dd_saved';
	protected $recurring = true;
	protected $group_recurring = 'DD';

	/**
	 * this function is the constructor of ControllerExtensionPaymentVrpayecommerceDdSaved class
	 *
	 * @return  void
	 */
	public function index() {
		return $this->confirmHtml();
	}

	/**
	 * Get a payment type
	 *
	 * @return  string
	 */
	function getPaymentType() {
	  return $this->getPaymentTypeSelection();
	}

	/**
	 * Get an account of payment method recurring
	 *
	 * @param   array  $payment_status
	 * @return  array
	 */
	function getAccount($payment_status) {
		$account = $payment_status[$this->account_type];
		$account['last4Digits'] = substr($account['iban'], -4);

		return $account;
	}
}
